/*
	file:
		dx9hook.h
	desc:
		This is the header file for dx9hook.cpp, the entrypoint.
*/

#ifndef DX9HOOK_H
#define DX9HOOK_H

#define WIN32_LEAN_AND_MEAN

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")

#include <windows.h>
#include <d3d9.h>
#include <d3dx9.h>
#include "IDirect3DDevice9Hook.h"
#include "IDirect3D9Hook.h"

HMODULE hOrigDll;
HINSTANCE hInst;
bool bWindowedMode;

IDirect3D9Hook D3D9Hook;

IDirect3D9 *pD3D;
IDirect3D9Hook *pD3DHook;
IDirect3DDevice9 *pD3DDevice;
IDirect3DDevice9Hook *pD3DDeviceHook;

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved);

typedef IDirect3D9* (WINAPI *Direct3DCreate9_t)(UINT SDKVersion);

FARPROC OldCheckFullscreen;
FARPROC OldD3DPERF_BeginEvent;
FARPROC OldD3DPERF_EndEvent;
FARPROC OldD3DPERF_GetStatus;
FARPROC OldD3DPERF_QueryRepeatFrame;
FARPROC OldD3DPERF_SetMarker;
FARPROC OldD3DPERF_SetOptions;
FARPROC OldD3DPERF_SetRegion;
FARPROC OldDebugSetLevel;
FARPROC OldDebugSetMute;
FARPROC OldDirect3DShaderValidatorCreate9;
FARPROC OldPSGPError;
FARPROC OldPSGPSampleTexture;
Direct3DCreate9_t OldDirect3DCreate9;

#endif